***************************************
* author Brunello Pulix
* Cagliari (Italy)
* brunellopulix@gmail.com
* placed in the public domain
***************************************
*
# include "hmg.ch"
*
# define _CARTELLA  "Cartella N"
# define _CARD      "Card"
*
#translate NTRIM( <v1> ) => ( Ltrim(str(<v1>)) )
*
Request dbfcdx
*
Procedure Main()
  *
  If !File('Temp90.Dbf')
     dbcreate("Temp90",{;
     {'CODICE','C', 3,0},;
     {'NOME'  ,'C',15,0},;
     {'CAMPO1','C',15,0},;
     {'CAMPO2','C',15,0},;
     {'CAMPO3','C',15,0},;
     {'N1'    ,'N', 1,0},;
     {'N2'    ,'N', 1,0},;
     {'N3'    ,'N', 1,0}},"DBFCDX")
     *
  Endif
  Use Temp90 New Exclusive Via 'DBFCDX'
  *
  If !File('Temp75.Dbf')
     dbcreate("Temp75.Dbf",{;
     {'CODICE','C', 3,0},;
     {'NOME'  ,'C',15,0},;
     {'CAMPO1','C',15,0},;
     {'CAMPO2','C',15,0},;
     {'CAMPO3','C',15,0},;
     {'N1'    ,'N', 1,0},;
     {'N2'    ,'N', 1,0},;
     {'N3'    ,'N', 1,0}},"DBFCDX")
     *
  Endif
  Use Temp75 New Exclusive Via 'DBFCDX'
  *
  FV3_OpenMain("Bingo Card Maker",nil,nil,{|| dbCloseAll() })
  FV3_SetValue('nCards',100)
  FV3_SetValue('Check1',.F.)
  *
  FV3_Button('Crea Nuova Base Dati',300,30,{|cWin| NuovaBaseDati()} )
  FV3_SkipRow(35)
  FV3_Label('Numero Cartelle (Max 999)',150)
  FV3_TextBox('nCards',50,'999',1)
  FV3_Label(' ',20)
  FV3_CheckBox('Check1',75,'MultiSelect2')
  FV3_SkipRow(30)
  *
  FV3_Button('1-90x9x3)' ,100,30,{|cWin| CreaColonne_90_9(3)   },.T.)
  FV3_Button('1-90x9x4)' ,100,30,{|cWin| CreaColonne_90_9(4)   },.T.)
  FV3_Button('1-90x9x10)',100,30,{|cWin| CreaColonne_90_9_2()  },.T.)
  *
  FV3_SkipRow(35)
  FV3_Button('1-75x9x3)' ,100,30,{|cWin| CreaColonne_75_9(3)  },.T.)
  FV3_Button('1-75x9x4)' ,100,30,{|cWin| CreaColonne_75_9(4)  },.T.)
  FV3_Button('1-75x9x10)',100,30,{|cWin| CreaColonne_75_9_2()},.T.)
  *
  FV3_SkipRow(45)
  FV3_Button('Demo Bingo 75',150,30,{|cWin| TestBingo(cWin,75) })
  FV3_Button('Demo Bingo 90',150,30,{|cWin| TestBingo(cWin,90) })
  *
  FV3_Show(1)
  *
Return
*
Procedure NuovaBaseDati()
  Local i
  Local aRay    := {}
  Local aCheck  := {}
  Local cString := ''
  *
  If MsgYesNo('Confermi aggiornamento?')
     dbSelectarea('Temp90')
     zap
     aRay   := {}
     aCheck := {}
     For i := 1 To FV3_GetProperty('nCards','Value')
        cString := CreaDati_90_9()
        If ascan(aCheck,{|n| Check[n] == cString }) == 0
           aadd(aRay,Str(i,3)+'|'+space(15)+cString)
        Endif
     Next
     *
     For i := 1 To Len(aRay)
        a1 := hb_ATokens(aRay[i],'|')
        Temp90->(dbappend())
        Replace Temp90->Codice with a1[1]
        Replace Temp90->Nome   with a1[2]
        Replace Temp90->Campo1 with a1[3]
        Replace Temp90->Campo2 with a1[4]
        Replace Temp90->Campo3 with a1[5]
     Next
     Temp90->(dbgotop())
     *
     dbSelectarea('Temp75')
     Zap
     *
     aRay   := {}
     aCheck := {}
     For i := 1 To FV3_GetProperty('nCards','Value')
        cString := CreaDati_75_9()
        If ascan(aCheck,{|n| Check[n] == cString }) == 0
           aadd(aRay,Str(i,3)+'|'+space(15)+cString)
        Endif
     Next
     *
     For i := 1 To Len(aRay)
        a1 := hb_ATokens(aRay[i],'|')
        Temp75->(dbappend())
        Replace Temp75->Codice with a1[1]
        Replace Temp75->Nome   with a1[2]
        Replace Temp75->Campo1 with a1[3]
        Replace Temp75->Campo2 with a1[4]
        Replace Temp75->Campo3 with a1[5]
     Next
     *
     Temp75->(dbgotop())
     Temp90->(dbgotop())
     *
     Msginfo('OK Nuova Base Dati creata')
     *
  Endif
  *
Return
*
Procedure CreaColonne_90_9(z)
  Local aTable := {}
  Local aTemp  := {}
  Local aRows  := {}
  Local a1     := {}
  Local c1     := ''
  Local n
  Local cRtf   := []
  *
  If z == 3
     cRtf   := [Cartelle_90x9x3.Rtf]
  else
     cRtf   := [Cartelle_90x9x4.Rtf]
  Endif
  *
  aTable := {}
  AAdd(aTable,{100})
  AAdd(aTable,{12,11,11,11,11,11,11,11,11})
  AAdd(aTable,{60,40})
  *
  RTF_OPEN(cRtf,aTable,'P')
  PutHeader(cRtf)
  *PutFooter()
  *
  x := 0
  dbselectarea('Temp90')
  If FV3_GetProperty('Check1','Value')
     aRows := MultiSelect2('Temp90')
  Endif
  aRay  := {}
  Temp90->(dbgotop())
  Do while Temp90->(!Eof())
     *
     If !Empty(aRows)
        if ascan(aRows,{|x| val(Temp90->Codice) == x } ) == 0
           Temp90->(dbskip())
           Loop
        Endif
     Endif
     *
     RTF_EmptyROW()
     *
     ++x
     *
     c1 := RtfStyle(_CARTELLA,"",'0',"70","")
     c1 += RtfStyle('o',"uX",'0',"70","")
     c1 += ' '+RtfStyle(Trim(Temp90->Codice),"b",'0',"80","")
     *
     RTF_WriteRow(3,{;
     MakeCell(c1,"40","l","LTR","",0,"","","",'B15'),;
     MakeCell(Upper(Trim(Temp90->Nome)),"40","l","BTR","i",0,"","","",'B15')})
     *
     a1 := OrdinaColonne_90_9(Temp90->Campo1)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
     MakeCell(a1[2],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
     MakeCell(a1[3],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
     MakeCell(a1[4],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
     MakeCell(a1[5],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
     MakeCell(a1[6],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
     MakeCell(a1[7],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
     MakeCell(a1[8],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
     MakeCell(a1[9],"70","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12',''))})
     *
     a1 := OrdinaColonne_90_9(Temp90->Campo2)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
     MakeCell(a1[2],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
     MakeCell(a1[3],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
     MakeCell(a1[4],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
     MakeCell(a1[5],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
     MakeCell(a1[6],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
     MakeCell(a1[7],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
     MakeCell(a1[8],"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
     MakeCell(a1[9],"70","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12',''))})
     *
     a1 := OrdinaColonne_90_9(Temp90->Campo3)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
     MakeCell(a1[2],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
     MakeCell(a1[3],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
     MakeCell(a1[4],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
     MakeCell(a1[5],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
     MakeCell(a1[6],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
     MakeCell(a1[7],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
     MakeCell(a1[8],"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
     MakeCell(a1[9],"70","c","BLTR","" ,0,"","",'',IF(Empty(a1[9]),'A12',''))})
     *
     If z == 4
        *RTF_EMPTYROW()
     else
        RTF_EMPTYROW()
        RTF_EMPTYROW()
        RTF_EMPTYROW()
        RTF_EMPTYROW()
     Endif
     *
     If x == z
        RTF_NEWSECTION()                              // Word
        *RTF_NEWPAGE('P')   // OpenOffice-LibreOffice
        x := 0
     Endif
     Temp90->(dbskip())
  Enddo
  Temp90->(dbgotop())
  *
  RTF_CLOSE()
  *
  execute file (cRtf)
  *
Return
*
Procedure CreaColonne_90_9_2()
  Local aRay   := {}
  Local aList  := {}
  Local Scelta
  Local aTable := {}
  Local c1     := ''
  Local c2     := ''
  Local a1     := {}
  Local a2     := {}
  Local aFlags := {'','','','','','','','',''}
  Local aTemp1 := {}
  Local aTemp2 := {}
  Local aTemp3 := {}
  Local aTemp4 := {}
  Local aRows  := {}
  Local i
  Local j
  Local n
  Local nBlock
  Local nPage
  Local cRtf   := [Cartelle_90x9x10.Rtf]
  *
  If FV3_GetProperty('Check1','Value')
     aRows := MultiSelect2('Temp90')
  Endif
  aRay  := {}
  Temp90->(dbgotop())
  If Empty(aRows)
     Do while Temp90->(!Eof())
        aadd(aRay,Temp90->Codice+'|'+Padr(Temp90->Nome,15)+'|'+Temp90->Campo1+'|'+Temp90->Campo2+'|'+Temp90->Campo3)
        Temp90->(dbskip())
     Enddo
  else
     Do while Temp90->(!Eof())
        if ascan(aRows,val(Temp90->Codice)) > 0
           aadd(aRay,Temp90->Codice+'|'+Padr(Temp90->Nome,15)+'|'+Temp90->Campo1+'|'+Temp90->Campo2+'|'+Temp90->Campo3)
        endif
        Temp90->(dbskip())
     Enddo
  endif
  *
  Temp90->(dbgotop())
  if Len(aRay) % 2 > 0
     aadd(aRay,[   |               |'' '' '' '' '' |'' '' '' '' '' |'' '' '' '' '' ])
  endif
  *
  aTable := {}
  AAdd(aTable,{100})
  AAdd(aTable,{5,6,5,5,6,5,5,6,5,5,5,6,5,5,6,5,5,6,5})
  AAdd(aTable,{29,19,5,29,19})
  *
  nBlock   := 0
  nPage    := 0
  nTotPage := Len(aRay)/10
  *
  RTF_OPEN(cRtf,aTable,'L',,,{297,210,15,30,10,10})
  PutHeader(cRtf)
  *
  For n := 1 To Len(aRay) step 2
     aTemp1 := {}
     aTemp2 := {}
     aTemp1 := hb_ATokens(aRay[n],'|')
     aadd(aTemp2,aTemp1[1])
     aadd(aTemp2,aTemp1[2])
     aadd(aTemp2,aTemp1[3])
     aadd(aTemp2,aTemp1[4])
     aadd(aTemp2,aTemp1[5])
     *
     aTemp3 := {}
     aTemp4 := {}
     aTemp3 := hb_ATokens(aRay[n+1],'|')
     aadd(aTemp4,aTemp3[1])
     aadd(aTemp4,aTemp3[2])
     aadd(aTemp4,aTemp3[3])
     aadd(aTemp4,aTemp3[4])
     aadd(aTemp4,aTemp3[5])
     *
     RTF_EMPTYROW()
     For i := 1 To 1
        *
        c1 := RtfStyle(_CARTELLA,"",'0',"35","")
        c1 += RtfStyle('o',"uX",'0',"35","")
        c1 += ' '+RtfStyle(aTemp2[1],"b",'0',"40","")
        *
        c2 := RtfStyle(_CARTELLA,"",'0',"35","")
        c2 += RtfStyle('o',"uX",'0',"35","")
        c2 += ' '+RtfStyle(aTemp4[1],"b",'0',"40","")
        *
        If Len(aRows) > 0
           RTF_WriteRow(3,{;
           MakeCell(c1       ,"20","l","LTR","" ,0,"","","",'B15'),;
           MakeCell(aTemp2[2],"40","l","BTR","i",0,"","","",'B15'),;
           MakeCell(''       ,"20","l",   "", "",0,"","","",''),;
           MakeCell(c2       ,"20","l","LTR", "",0,"","","",'B15'),;
           MakeCell(If(!Empty(aTemp4[2]),aTemp4[2],''),"40","l","BTR","i",0,"","","",'B15')})
        else
           RTF_WriteRow(3,{;
           MakeCell(c1 ,"20","l","LTR","" ,0,"","","",'B15'),;
           MakeCell('' ,"40","l","BTR","i",0,"","","",'B15'),;
           MakeCell('' ,"20","l",   "", "",0,"","","",''),;
           MakeCell(c2 ,"20","l","LTR", "",0,"","","",'B15'),;
           MakeCell('' ,"40","l","BTR","i",0,"","","",'B15')})
        endif
        *
        a1 := OrdinaColonne_90_9(aTemp2[3])
        a2 := OrdinaColonne_90_9(aTemp4[3])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""   ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        a1 := OrdinaColonne_90_9(aTemp2[4])
        a2 := OrdinaColonne_90_9(aTemp4[4])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""   ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        a1 := OrdinaColonne_90_9(aTemp2[5])
        a2 := OrdinaColonne_90_9(aTemp4[5])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTBR" ,"" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""    ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTBR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        *
        ++nBlock
        *
     Next
     If nBlock == 5
        ++nPage
        If nPage == int(Len(aRay)/10)
           exit
        else
           RTF_NEWSECTION()                            // Word
           *RTF_NEWPAGE('P')   // OpenOffice-LibreOffice
        Endif
        nBlock := 0
     Endif
  Next
  *
  RTF_CLOSE()
  *
  execute file (cRtf)
  *
Return
*
Procedure CreaColonne_75_9(z)
  Local aTable := {}
  Local aTemp  := {}
  Local aRows  := {}
  Local a1     := {}
  Local c1     := ''
  Local c2     := ''
  Local n
  Local cRtf   := ''
  *
  If z == 3
     cRtf := [Cartelle_75x9x3.Rtf]
  else
     cRtf := [Cartelle_75x9x4.Rtf]
  Endif
  *
  aTable := {}
  AAdd(aTable,{100})
  AAdd(aTable,{12,11,11,11,11,11,11,11,11})
  AAdd(aTable,{60,40})
  *
  RTF_OPEN(cRtf,aTable,'P')
  PutHeader(cRtf)
  *PutFooter()
  *
  x := 0
  dbselectarea('Temp75')
  If FV3_GetProperty('Check1','Value')
     aRows := MultiSelect2('Temp75')
  Endif
  Temp75->(dbgotop())
  *
  Do while Temp75->(!Eof())
     *
     If !Empty(aRows)
        if ascan(aRows,{|x| val(Temp75->Codice) == x } ) == 0
           Temp75->(dbskip())
           Loop
        Endif
     Endif
     *
     RTF_EMPTYROW()
     *
     ++x
     *
     c1 := RtfStyle(_CARTELLA,"",'0',"70","")
     c1 += RtfStyle('o',"uX",'0',"70","")
     c1 += ' '+RtfStyle(Trim(Temp75->Codice),"b",'0',"80","")
     *
     RTF_WriteRow(3,{;
     MakeCell(c1,"40","l","LTR","",0,"","","",'B15'),;
     MakeCell(Upper(Trim(Temp75->Nome)),"40","l","BTR","i",0,"","","",'B15')})
     *
     a1 := OrdinaColonne_75_9(Temp75->Campo1)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]) ,'A12','')),;
     MakeCell(a1[2]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]) ,'A12','')),;
     MakeCell(a1[3]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]) ,'A12','')),;
     MakeCell(a1[4]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]) ,'A12','')),;
     MakeCell(a1[5]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]) ,'A12','')),;
     MakeCell(a1[6]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]) ,'A12','')),;
     MakeCell(a1[7]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]) ,'A12','')),;
     MakeCell(a1[8]  ,"70","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]) ,'A12','')),;
     MakeCell(a1[9]  ,"70","c","LTR","" ,0,"","",'',IF(Empty(a1[9]) ,'A12',''))})
     *
     a1 := OrdinaColonne_75_9(Temp75->Campo2)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[1])  ,'A12' ,'')),;
     MakeCell(a1[2]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[2])  ,'A12' ,'')),;
     MakeCell(a1[3]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[3])  ,'A12' ,'')),;
     MakeCell(a1[4]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[4])  ,'A12' ,'')),;
     MakeCell(a1[5]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[5])  ,'A12' ,'')),;
     MakeCell(a1[6]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[6])  ,'A12' ,'')),;
     MakeCell(a1[7]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[7])  ,'A12' ,'')),;
     MakeCell(a1[8]  ,"70","c","LT"  ,"" ,0,"","",'',IF(Empty(a1[8])  ,'A12' ,'')),;
     MakeCell(a1[9]  ,"70","c","LTR" ,"" ,0,"","",'',IF(Empty(a1[9])  ,'A12' ,''))})
     *
     a1 := OrdinaColonne_75_9(Temp75->Campo3)
     *
     RTF_WRITEROW(2,{;
     MakeCell(a1[1]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
     MakeCell(a1[2]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
     MakeCell(a1[3]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
     MakeCell(a1[4]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
     MakeCell(a1[5]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
     MakeCell(a1[6]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
     MakeCell(a1[7]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
     MakeCell(a1[8]  ,"70","c","BLT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
     MakeCell(a1[9]  ,"70","c","BLTR","" ,0,"","",'',IF(Empty(a1[9]),'A12',''))})
     *
     If z == 4
        *RTF_EMPTYROW()
     else
        RTF_EMPTYROW()
        RTF_EMPTYROW()
        RTF_EMPTYROW()
        RTF_EMPTYROW()
     Endif
     *
     If x == z
        RTF_NEWSECTION()                              // Word
        *RTF_NEWPAGE('P')   // OpenOffice-LibreOffice
        x := 0
     Endif
     Temp75->(dbskip())
  Enddo
  Temp75->(dbgotop())
  *
  RTF_CLOSE()
  *
  execute file (cRtf)
  *
Return
*
*
Procedure PutHeader(c)
  *
  c += " -  by brunellopulix@gmail.com - (Italy)"
  RTF_OpenHeader('')
  RTF_WriteRow(1,{MakeCell(c,"22","c","B","bi",0,"","","")})
  RTF_CloseTag()
  *
Return
*
Procedure PutFooter()
  *
  RTF_OpenFooter('')
  RTF_WriteRow(1,{MakeCell("by brunellopulix@gmail.com - (Italy)","22","c","T","ib",0,"","","")})
  RTF_CloseTag()
  *
Return
*
Procedure AKill( a, n )
  ASize( ADel( a, n ), Len( a ) - 1 )
Return
*
Procedure CreaColonne_75_9_2()
  Local aRay   := {}
  Local aList  := {}
  Local Scelta
  Local aTable := {}
  Local c1     := ''
  Local c2     := ''
  Local a1     := {}
  Local a2     := {}
  Local aFlags := {'','','','','','','','',''}
  Local aTemp1 := {}
  Local aTemp2 := {}
  Local aTemp3 := {}
  Local aTemp4 := {}
  Local i
  Local j
  Local n
  Local nBlock
  Local nPage
  Local cRtf   := [Cartelle_75x9x10.Rtf]
  Local aRows  := {}
  *
  If FV3_GetProperty('Check1','Value')
     aRows := MultiSelect2('Temp75')
  Endif
  aRay  := {}
  Temp75->(dbgotop())
  If Empty(aRows)
     Do while Temp75->(!Eof())
        aadd(aRay,Temp75->Codice+'|'+Padr(Temp75->Nome,15)+'|'+Temp75->Campo1+'|'+Temp75->Campo2+'|'+Temp75->Campo3)
        Temp75->(dbskip())
     Enddo
  else
     Do while Temp75->(!Eof())
        if ascan(aRows,val(Temp75->Codice)) > 0
           aadd(aRay,Temp75->Codice+'|'+Padr(Temp75->Nome,15)+'|'+Temp75->Campo1+'|'+Temp75->Campo2+'|'+Temp75->Campo3)
        endif
        Temp75->(dbskip())
     Enddo
  endif
  *
  Temp75->(dbgotop())
  if Len(aRay) % 2 > 0
     aadd(aRay,[   |               |'' '' '' '' '' |'' '' '' '' '' |'' '' '' '' '' '])
  endif
  *
  aTable := {}
  AAdd(aTable,{100})
  AAdd(aTable,{5,6,5,5,6,5,5,6,5,5,5,6,5,5,6,5,5,6,5})
  AAdd(aTable,{29,19,5,29,19})
  *
  nBlock   := 0
  nPage    := 0
  nTotPage := Len(aRay)/10
  *
  RTF_OPEN(cRtf,aTable,'L',,,{297,210,15,30,10,10})
  PutHeader(cRtf)
  *
  For n := 1 To Len(aRay) step 2
     aTemp1 := {}
     aTemp2 := {}
     aTemp1 := hb_ATokens(aRay[n],'|')
     aadd(aTemp2,aTemp1[1])
     aadd(aTemp2,aTemp1[2])
     aadd(aTemp2,aTemp1[3])
     aadd(aTemp2,aTemp1[4])
     aadd(aTemp2,aTemp1[5])
     *
     aTemp3 := {}
     aTemp4 := {}
     aTemp3 := hb_ATokens(aRay[n+1],'|')
     aadd(aTemp4,aTemp3[1])
     aadd(aTemp4,aTemp3[2])
     aadd(aTemp4,aTemp3[3])
     aadd(aTemp4,aTemp3[4])
     aadd(aTemp4,aTemp3[5])
     *
     RTF_EMPTYROW()
     For i := 1 To 1
        *
        c1 := RtfStyle(_CARTELLA,"",'0',"35","")
        c1 += RtfStyle('o',"uX",'0',"35","")
        c1 += ' '+RtfStyle(aTemp2[1],"b",'0',"40","")
        *
        c2 := RtfStyle(_CARTELLA,"",'0',"35","")
        c2 += RtfStyle('o',"uX",'0',"35","")
        c2 += ' '+RtfStyle(aTemp4[1],"b",'0',"40","")
        *
        If Len(aRows) > 0
           RTF_WriteRow(3,{;
           MakeCell(c1       ,"20","l","LTR","" ,0,"","","",'B15'),;
           MakeCell(aTemp2[2],"40","l","BTR","i",0,"","","",'B15'),;
           MakeCell(''       ,"20","l",   "", "",0,"","","",''),;
           MakeCell(c2       ,"20","l","LTR", "",0,"","","",'B15'),;
           MakeCell(If(!Empty(aTemp4[2]),aTemp4[2],''),"40","l","BTR","i",0,"","","",'B15')})
        else
           RTF_WriteRow(3,{;
           MakeCell(c1 ,"20","l","LTR","" ,0,"","","",'B15'),;
           MakeCell('' ,"40","l","BTR","i",0,"","","",'B15'),;
           MakeCell('' ,"20","l",   "", "",0,"","","",''),;
           MakeCell(c2 ,"20","l","LTR", "",0,"","","",'B15'),;
           MakeCell('' ,"40","l","BTR","i",0,"","","",'B15')})
        endif
        *
        /*
        RTF_WriteRow(3,{;
        MakeCell(c1,"20","l","LTR","" ,0,"","","",'B15'),;
        MakeCell('',"20","l","BTR","i",0,"","","",'B15'),;
        MakeCell('',"20","l",   "", "",0,"","","",''),;
        MakeCell(c2,"20","l","LTR", "",0,"","","",'B15'),;
        MakeCell('',"20","l","BTR","i",0,"","","",'B15')})
        */
        a1 := OrdinaColonne_75_9(aTemp2[3])
        a2 := OrdinaColonne_75_9(aTemp4[3])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""   ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        a1 := OrdinaColonne_75_9(aTemp2[4])
        a2 := OrdinaColonne_75_9(aTemp4[4])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""   ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LT" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        a1 := OrdinaColonne_75_9(aTemp2[5])
        a2 := OrdinaColonne_75_9(aTemp4[5])
        *
        RTF_WRITEROW(2,{;
        MakeCell(a1[1],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[1]),'A12','')),;
        MakeCell(a1[2],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[2]),'A12','')),;
        MakeCell(a1[3],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[3]),'A12','')),;
        MakeCell(a1[4],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[4]),'A12','')),;
        MakeCell(a1[5],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[5]),'A12','')),;
        MakeCell(a1[6],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[6]),'A12','')),;
        MakeCell(a1[7],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[7]),'A12','')),;
        MakeCell(a1[8],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a1[8]),'A12','')),;
        MakeCell(a1[9],"35","c","LTBR","" ,0,"","",'',IF(Empty(a1[9]),'A12','')),;
        MakeCell(''   ,"10","c",""    ,"" ,0,"","","",''),;
        MakeCell(a2[1],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[1]),'A12','')),;
        MakeCell(a2[2],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[2]),'A12','')),;
        MakeCell(a2[3],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[3]),'A12','')),;
        MakeCell(a2[4],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[4]),'A12','')),;
        MakeCell(a2[5],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[5]),'A12','')),;
        MakeCell(a2[6],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[6]),'A12','')),;
        MakeCell(a2[7],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[7]),'A12','')),;
        MakeCell(a2[8],"35","c","LTB" ,"" ,0,"","",'',IF(Empty(a2[8]),'A12','')),;
        MakeCell(a2[9],"35","c","LTBR","" ,0,"","",'',IF(Empty(a2[9]),'A12',''))})
        *
        *
        ++nBlock
        *
     Next
     If nBlock == 5
        ++nPage
        If nPage == int(Len(aRay)/10)
           exit
        else
           RTF_NEWSECTION()                            // Word
           *RTF_NEWPAGE('P')   // OpenOffice-LibreOffice
        Endif
        nBlock := 0
     Endif
  Next
  *
  RTF_CLOSE()
  *
  execute file (cRtf)
  *
Return
*
Procedure CreaDati_75_9()
  Local aLista    := {}
  Local aEstratti := {}
  Local aCol      := {}
  Local i
  Local h
  Local c1
  Local c2
  *
  For i := 1 To 75
     aadd(aEstratti,i)
  Next
  *
  c1 := ''
  For h := 1 To 3
     aCol := {}
     If h == 1
        XYZ(01,08,@aLista,aEstratti,@aCol)
        XYZ(17,24,@aLista,aEstratti,@aCol)
        XYZ(33,40,@aLista,aEstratti,@aCol)
        XYZ(49,56,@aLista,aEstratti,@aCol)
        XYZ(65,72,@aLista,aEstratti,@aCol)
     elseif h == 2
        XYZ(08,16,@aLista,aEstratti,@aCol)
        XYZ(25,32,@aLista,aEstratti,@aCol)
        XYZ(41,48,@aLista,aEstratti,@aCol)
        XYZ(57,64,@aLista,aEstratti,@aCol)
        XYZ(71,75,@aLista,aEstratti,@aCol)
     else
        XYZ(01,07,@aLista,aEstratti,@aCol)
        XYZ(21,25,@aLista,aEstratti,@aCol)
        XYZ(26,35,@aLista,aEstratti,@aCol)
        XYZ(44,50,@aLista,aEstratti,@aCol)
        XYZ(71,75,@aLista,aEstratti,@aCol)
     Endif
     asort(aCol,,,{|x,y| x < y })
     *
     c1 += '|'
     For i := 1 To Len(aCol)
        c1 += Strzero(aCol[i],2)+' '
     Next
     aCol := {}
  Next
  *
Return c1
*
Procedure CreaDati_90_9()
  Local aLista := {}
  Local aEstratti := {}
  Local aEsclusi  := {}
  Local aCol      := {}
  Local i
  Local n
  Local h
  Local c1
  Local c2
  *
  For i := 1 To 90
     aadd(aEstratti,i)
  Next
  *
  c1 := ''
  For h := 1 To 3
     aCol := {}
     *
     If h == 1
        XYZ(01,09,@aLista,aEstratti,@aCol)
        XYZ(20,29,@aLista,aEstratti,@aCol)
        XYZ(40,49,@aLista,aEstratti,@aCol)
        XYZ(60,69,@aLista,aEstratti,@aCol)
        XYZ(70,79,@aLista,aEstratti,@aCol)
     elseif h == 2
        XYZ(10,19,@aLista,aEstratti,@aCol)
        XYZ(30,39,@aLista,aEstratti,@aCol)
        XYZ(50,59,@aLista,aEstratti,@aCol)
        XYZ(70,79,@aLista,aEstratti,@aCol)
        XYZ(80,85,@aLista,aEstratti,@aCol)
     else
        XYZ(01,09,@aLista,aEstratti,@aCol)
        XYZ(20,29,@aLista,aEstratti,@aCol)
        XYZ(40,49,@aLista,aEstratti,@aCol)
        XYZ(60,69,@aLista,aEstratti,@aCol)
        XYZ(85,90,@aLista,aEstratti,@aCol)
     Endif
     asort(aCol,,,{|x,y| x < y })
     *
     c1 += '|'
     For i := 1 To Len(aCol)
        c1 += Strzero(aCol[i],2)+' '
     Next
     *
     aCol := {}
     *
  Next
  *
Return c1
*
Procedure MyChoice(nWidth,nHeight,aRay,cCaption,nValue)
  Local nRet := 0
  *
  hb_Default(@nWidth,300)
  hb_Default(@nHeight,200)
  hb_Default(@nValue,1)
  *
  M->_LSTBOX_ := ''
  *
  FV3_OpenModal(cCaption,nil,{|cWin| SetProperty(cWin,'_LSTBOX_','Value',nValue) })
  FV3_ListBox('_LSTBOX_',nWidth,nHeight,aRay,.F.,{|| FV3_Okay()})
  *
  FV3_SetFont('_LSTBOX_','Courier New',9)
  *
  FV3_Show(2)
  *
  If FV3_Result()
     nRet := M->_LSTBOX_
  Endif
  *
Return nRet
*
# define _TEXT1 [Estratto (Manuale)]
# define _TEXT2 [Estratto (Continuo)]
# define _TEXT3 [Nuovo Gioco]
# define _TEXT4 [Browse]
# define _TEXT5 [Statistiche (F2)]
*
Procedure TestBingo(cWin,nTest)
  Private aYellow     := {255,255,0}
  Private aGreen      := {128,255,0}
  Private aRed        := {255,0,0}
  Private aWhite      := {255,255,255}
  Private aPink       := {255,0,128}
  Private aCYAN       := {0,128,128}
  Private aBLUE       := {0,0,255}
  Private aGRAY       := {192,192,192}
  Private aMAGENTA    := {255,0,255}
  Private aBlack      := {0,0,0}
  Private aEstratto   := {}
  Private aAscendente := {}
  Private aSequenza   := {}
  Private nTestBingo  := nTest
  Private cSequ       := []
  Private cAsce       := []
  Private aGames      := {}
  Private nTime       := 1500
  Private xBingo      := .F.
  *
  Private cHeader := " -  by brunellopulix@gmail.com - (Italy)"
  *
  If !File('Time.Txt')
     hb_Memowrit('Time.Txt','1200')
  Endif
  nTime := Val(hb_MemoRead('Time.Txt'))
  *
  If nTest == 75
     DbSelectarea('Temp75')
     Test75()
  Else
     DbSelectarea('Temp90')
     Test90()
  Endif
Return
*
Procedure Test75()
  Local i
  Local cNum
  *
  FV3_OpenModal('Bingo 75'+cHeader,nil,;
  {|cWin| PostInitBingo(cWin) },nil)
  *
  For i := 1 To nTestBingo
     cNum := ntrim(i)
     FV3_SetValue('X'+cNum,cNum)
  Next
  FV3_SetValue('H1'  ,'0')
  FV3_SetValue('Radio1',1)
  *
  For i := 1 To nTestBingo
     *
     FV3_FramedText3('X'+ntrim(i),60,1,aYellow,'Arial',36,nil,.T.)
     If i % 15 == 0
        FV3_SkipRow(70)
     else
        FV3_Label(' ',5)
     Endif
     *
  Next
  *
  FV3_SkipRow(10)
  FV3_Button(_TEXT1 ,110,30,{|cWin| FV3_DisableButton(_TEXT2),Estra0(cWin)},.F.)
  FV3_Label(' ',5)
  FV3_Button(_TEXT2 ,110,30,{|cWin| FV3_DisableButton(_TEXT1),Estra2(cWin)},.F.)
  FV3_Label(' ',5)
  FV3_Button(_TEXT3 ,110,30,{|| NuovoGioco()   }) ; FV3_Label(' ',5)
  FV3_Button(_TEXT4 ,110,30,{|| MyBrowse()     }) ; FV3_Label(' ',5)
  FV3_Button(_TEXT5 ,110,30,{|| Statistiche()  }) ; FV3_Label(' ',5)
  FV3_ButtonCancel('Fine'       ,110,30)
  FV3_SkipRow(-15)
  FV3_SetCol(735)
  *
  FV3_FramedText3('H1',250,1,aGreen)
  FV3_SkipRow(260)
  *
  FV3_Show(0)
  *
  IF FV3_Result()
     *
  Endif
  *
Return
*
Procedure PostInitBingo(cWin)
  Local i
  *
  If nTestBingo == 75
     SetProperty(cWin,'Height',700)
  else
     SetProperty(cWin,'Height',700)
  Endif
  *
  SetProperty(cWin,'H1','BackColor',aGreen  )
  SetProperty(cWin,'H1','Height'   ,253     )
  SetProperty(cWin,'H1','FontName' ,'Arial' )
  SetProperty(cWin,'H1','FontSize' ,170     )
  SetProperty(cWin,'H1','FontBold' ,.T.     )
  SetProperty(cWin,'H1','Alignment','Center')
  *
  For i := 1 To nTestBingo
     SetProperty(cWin,'X'+ntrim(i),'Height',60)
  Next
  *
Return
*
Procedure Estra0(cWin)
  Local i
  *
  Estra1(cWin)
  If xBingo
     FV3_DisableButton(_TEXT1)
     FV3_DisableButton(_TEXT2)
     Do while !Empty(aEstratto)
        Estra1(cWin)
        DoMethod(cWin,'SetFocus')
        do events
        sleep(nTime)
     Enddo
     xBingo := .F.
  Endif
  *
Return
*
Procedure Estra1(cWin)
  Local n,i,j
  *
  If empty(aEstratto)
     Return
  Endif
  *
  n := aEstratto[1]
  aadd(aSequenza,n)
  aadd(aAscendente,n)
  FV3_SetProperty('X'+ntrim(n),'BackColor',aRed)
  FV3_SetProperty('X'+ntrim(n),'ForeColor',aWhite)
  FV3_SetProperty('H1','Value',ntrim(n))
  asort(aAscendente)
  *
  cSequ += '-'+ntrim(n)
  *
  cAsce := ''
  For i := 1 To Len(aAscendente)
     cAsce += '-'+ntrim(aAscendente[i])
  Next
  CheckFolders(ntrim(n),cWin)
  *
  aKill(aEstratto,1)
  *
  If Empty(aEstratto)
     FV3_DisableButton(_TEXT1)
     FV3_DisableButton(_TEXT2)
     FV3_EnableButton(_TEXT3)
     FV3_EnableButton(_TEXT4)
  Endif
  *
Return
*
Procedure Estra2(cWin)
  Local i
  *
  _DefineHotKey ( cWin, 0 , VK_F2 , {|| Statistiche() } )
  *
  For i := 1 To nTestBingo
     Estra1(cWin)
     DoMethod(cWin,'SetFocus')
     do events
     sleep(nTime)
  Next
  *
  xBingo := .F.
  If nTestBingo == 90
     FV3_Enabled('G2',.T.)
     FV3_Enabled('G3',.T.)
     FV3_Enabled('G4',.T.)
     FV3_Enabled('G5',.T.)
  Endif
  *
Return
*
Procedure NuovoGioco()
  Local c1
  Local c2
  Local n
  Local a1 := {}
  *
  aEstratto   := {}
  aAscendente := {}
  aSequenza   := {}
  *
  For n := 1 To nTestBingo
     FV3_SetProperty('X'+ntrim(n),'BackColor',aYellow)
     FV3_SetProperty('X'+ntrim(n),'ForeColor',aBlack)
  Next
  FV3_SetProperty('H1','Value','0')
  cSequ       := []
  cAsce       := []
  *
  AzzeraDbf()
  *
  Do while .T.
     *
     n := hb_RandomInt(nTestBingo)
     If n > 0
        If ascan(aEstratto,n) == 0
           aadd(aEstratto,n)
        Endif
     Endif
     If Len(aEstratto) == nTestBingo
        *Msginfo('OK Operazione Riuscita!')
        exit
     Endif
  enddo
  *
  FV3_EnableButton(_TEXT1)
  FV3_EnableButton(_TEXT2)
  FV3_DisableButton(_TEXT3)
  FV3_DisableButton(_TEXT4)
  *
  If nTestBingo == 90
     *
     aadd(a1,FV3_GetProperty('G2','Value') )
     aadd(a1,FV3_GetProperty('G3','Value') )
     aadd(a1,FV3_GetProperty('G4','Value') )
     aadd(a1,FV3_GetProperty('G5','Value') )
     *
     If a1[1]
        If ascan(aGames,{|_a| _a[1] == 2 }) == 0
           aadd(aGames,{2,{|| (alias())->N1 == 2 .or. (alias())->N2 == 2 .or. (alias())->N3 == 2 },'Ambo','G2'})
        Endif
     Endif
     *
     If a1[2]
        If ascan(aGames,{|_a| _a[1] == 3 }) == 0
           aadd(aGames,{3,{|| (alias())->N1 == 3 .or. (alias())->N2 == 3 .or. (alias())->N3 == 3 },'Terno','G3'})
        Endif
     Endif
     *
     If a1[3]
        If ascan(aGames,{|_a| _a[1] == 4 }) == 0
           aadd(aGames,{4,{|| (alias())->N1 == 4 .or. (alias())->N2 == 4 .or. (alias())->N3 == 4 },'Quaterna','G4'})
        Endif
     Endif
     *
     If a1[4]
        If ascan(aGames,{|_a| _a[1] == 5 }) == 0
           aadd(aGames,{5,{|| (alias())->N1 == 5 .or. (alias())->N2 == 5 .or. (alias())->N3 == 5 },'Cinquina','G5'})
        Endif
     Endif
     *
     asort(aGames,,,{|x,y| x[1] < y[1] })
     *
     FV3_Enabled('G2',.F.)
     FV3_Enabled('G3',.F.)
     FV3_Enabled('G4',.F.)
     FV3_Enabled('G5',.F.)
     *
  Endif
  *
Return
*
Procedure Test90()
  Local i
  Local cNum
  Local cHeader := " -  by brunellopulix@gmail.com - (Italy)"
  *
  aGames := {}
  *
  FV3_OpenModal('Bingo 90'+cHeader,,{|cWin| PostInitBingo(cWin) },nil)
  *
  FV3_SetValue('G2',.F.)
  FV3_SetValue('G3',.F.)
  FV3_SetValue('G4',.F.)
  FV3_SetValue('G5',.F.)
  *
  For i := 1 To nTestBingo
     cNum := ntrim(i)
     FV3_SetValue('X'+cNum,cNum)
  Next
  FV3_SetValue('H1'  ,'0')
  FV3_SetValue('Radio1',1)
  *
  For i := 1 To nTestBingo
     *
     FV3_FramedText3('X'+ntrim(i),60,1,aYellow,'Arial',36,nil,.T.)
     If i % 10 == 0
        FV3_SkipRow(70)
     else
        FV3_Label(' ',5)
     Endif
     *
  Next
  *
  FV3_SetPos(-627,660)
  FV3_FramedText2('Tombola Italiana',250,1)
  *
  FV3_SetPos(30,660)
  FV3_CheckBox('G2',080,'Ambo')
  *
  FV3_SetPos(30,660)
  FV3_CheckBox('G3',080,'Terno')
  *
  FV3_SetPos(30,660)
  FV3_CheckBox('G4',080,'Quaterna')
  *
  FV3_SetPos(30,660)
  FV3_CheckBox('G5',080,'Cinquina')
  *
  FV3_SetPos(30,660)
  FV3_Button(_TEXT1,250,30,{|cWin| FV3_DisableButton(_TEXT2),Estra0(cWin)},.F.)
  *
  FV3_SetPos(30,660)
  FV3_Button(_TEXT2,250,30,{|cWin| FV3_DisableButton(_TEXT1),Estra2(cWin)},.F.)
  *
  FV3_SetPos(30,660)
  FV3_Button(_TEXT3 ,250,30,{|| NuovoGioco()      })
  *
  FV3_SetPos(30,660)
  FV3_Button(_TEXT4 ,250,30,{|| MyBrowse()        })
  *
  FV3_SetPos(30,660)
  FV3_Button(_TEXT5 ,250,30,{|| Statistiche()     })
  *
  FV3_SetPos(30,670)
  FV3_ButtonCancel('Fine',250,30)
  *
  FV3_SetPos(65,660)
  FV3_FramedText3('H1',250,1,aGreen)
  *
  FV3_Show(0)
  *
  IF FV3_Result()
     *
  Endif
  *
Return
*
Procedure CheckFolders(c1,cWin)
  Local c2
  Local c3
  Local i
  Local n
  Local j
  Local lBingo := .F.
  Local bLock1
  Local a1     := {}
  Local a2     := {}
  *
  (alias())->(dbgotop())
  Do while (alias())->(!Eof())
     *
     If !Empty((alias())->Nome)
        If val(c1) < 10
           c2 := Left('0'+c1,2)
        else
           c2 := c1
        endif
        *
        If c2 $ (alias())->Campo1
           i := (alias())->N1
           Replace (alias())->N1 with i+1
           c3 := StrTran((alias())->Campo1,c2+' ',c2+'.')
           Replace (alias())->Campo1 with c3
        elseif c2 $ (alias())->Campo2
           i := (alias())->N2
           Replace (alias())->N2 with i+1
           c3 := StrTran((alias())->Campo2,c2+' ',c2+'.')
           Replace (alias())->Campo2 with c3
        elseif c2 $ (alias())->Campo3
           i := (alias())->N3
           Replace (alias())->N3 with i+1
           c3 := StrTran((alias())->Campo3,c2+' ',c2+'.')
           Replace (alias())->Campo3 with c3
        Endif
     Endif
     (alias())->(dbskip())
  Enddo
  a1 := {}
  bLock1 := {|| (alias())->N1+(alias())->N2+(alias())->N3 == 15 }
  (alias())->(dbgotop())
  Do while (alias())->(!Eof())
     *
     If eval(bLock1)
        aadd(a1,{;
        (alias())->Codice,;
        (alias())->Nome  ,;
        StrTran((alias())->Campo1,'.',' '),;
        StrTran((alias())->Campo2,'.',' '),;
        StrTran((alias())->Campo3,'.',' ')})
        xBingo := .T.
     Endif
     *
     If nTestBingo == 90 .and. !empty(aGames)
        If !Empty(aGames)
           If eval(aGames[1,2])
              aadd(a2,{;
              (alias())->Codice,;
              (alias())->Nome  ,;
              (alias())->Campo1,;
              (alias())->Campo2,;
              (alias())->Campo3})
           Endif
        Endif
     Endif
     *
     (alias())->(dbskip())
  Enddo
  *
  (alias())->(dbgotop())
  *
  If !Empty(a1)
     AzzeraDbf()
     ShowRtf(a1,0)
     *
  Endif
  If nTestBingo == 90
     If !Empty(a2)
        ShowRtf(a2)
     Endif
  Endif
  *
Return
*
Procedure AzzeraDbf()
  *
  (alias())->(dbgotop())
  Do while (alias())->(!Eof())
     *
     c2 := StrTran((alias())->Campo1,'.',' ')
     Replace (alias())->Campo1 with c2
     *
     c2 := StrTran((alias())->Campo2,'.',' ')
     Replace (alias())->Campo2 with c2
     *
     c2 := StrTran((alias())->Campo3,'.',' ')
     Replace (alias())->Campo3 with c2
     *
     Replace (alias())->N1 with 0
     Replace (alias())->N2 with 0
     Replace (alias())->N3 with 0
     *
     (alias())->(dbskip())
     *
  Enddo
  *
  (alias())->(dbgotop())
  *
Return
*
Procedure ShowRtf(a)
  *
  FV3_OpenModal('Bingo '+NTrim(nTestBingo),nil,{|cWin| RtfInit2(cWin,a) },nil)
  FV3_RtfBox('RTF2',400,400)
  FV3_Show(1)
  IF FV3_Result()
  Endif
  *
Return
*
Procedure RtfInit2(cWin,a)
  Local aTable := {}
  Local aTemp  := {}
  Local cRtf   := 'Temp.Rtf'
  Local i
  Local j
  Local h
  Local c1
  Local c2
  *
  aadd(aTable,{100})
  aadd(aTable,{20,80})
  *
  Ferase(cRtf)
  *
  If Len(aGames) > 0
     For i := 1 To Len(a)
        For j := 3 To 5
           c2 := ''
           If '.' $ a[i,j]
              c1         :=   a[i,j]
              aTemp      :=   array(5)
              aTemp[1]   :=   Trim(Substr(c1,1,3))
              aTemp[2]   :=   Trim(Substr(c1,4,3))
              aTemp[3]   :=   Trim(Substr(c1,7,3))
              aTemp[4]   :=   Trim(Substr(c1,10,3))
              aTemp[5]   :=   Trim(Substr(c1,13,3))
              For h := 1 To Len(aTemp)
                 if Right(aTemp[h],1) == '.'
                    c2 += aTemp[h]
                 endif
              Next
           Endif
           a[i,j] := StrTran(c2,'.',' ')
        Next
     Next
  Endif
  *
  RTF_Open(cRtf,aTable,'P',,,{109,155,3,3,3,3},,)
  *
  If nTestBingo == 90 .and. Len(aGames) > 0
     RTF_WriteFree(MakeCell(aGames[1,3],"50","c","" ,"bu",0,"","","1",""))
  else
     RTF_WriteFree(MakeCell('BINGO '+NTrim(nTestBingo),"50","c","" ,"bu",0,"","","1",""))
  Endif
  *
  RTF_WriteFree(MakeCell('Vincitori:',"30","l","" ,"u",0,"","","",""))
  *
  For i := 1 To Len(a)
     *
     RTF_WriteRow(2,{;
     MakeCell([Cartella N.],"20","r","" ,"u",0,"","","",''),;
     MakeCell(a[i,1],"30","l","" ,"b",0,"","","",'')})
     *
     RTF_WriteRow(2,{;
     MakeCell([Giocatore:],"20","r","" ,"",0,"","","",''),;
     MakeCell(a[i,2],"30","l","" ,"b",0,"","","",'')})
     *
     RTF_WriteRow(2,{;
     MakeCell([Gruppo 1:],"20","r","" ,"",0,"","","",''),;
     MakeCell(a[i,3],"30","l","" ,"b",0,"","","",'')})
     *
     RTF_WriteRow(2,{;
     MakeCell([Gruppo 2:],"20","r","" ,"",0,"","","",''),;
     MakeCell(a[i,4],"30","l","" ,"b",0,"","","",'')})
     *
     RTF_WriteRow(2,{;
     MakeCell([Gruppo 3:],"20","r","" ,"",0,"","","",''),;
     MakeCell(a[i,5],"30","l","" ,"b",0,"","","",'')})
     *
     RTF_WriteFree(MakeCell('',"20","l","" ,"",0,"","","",''))
     *
  Next
  *
  RTF_Close()
  If Len(aGames) > 0
     aKill(aGames,1)
  Endif
  *
  FV3_DoMethod('RTF2','RTFLoadFile',cRtf)
  FV3_DoMethod('RTF2','Refresh')
  *
Return
*
Procedure MyBrowse()
  *
  Private cAlias := (Alias())
  *
  FV3_OpenModal('Caption')
  FV3_Browse('BROW4',650,465,{30,120,120,40,120,40,120,40},{'#','Nome','Gruppo1','..','Gruppo2','..','Gruppo3','..'},cAlias,{'Codice','Nome','Campo1','N1','Campo2','N2','Campo3','N3'},{|| Modifica() },nil,nil,nil,nil,.T.)
  FV3_SkipRow(10)
  FV3_Button('Modifica'    ,100,30,{|| Modifica() })
  FV3_Button('Svuota Campi',100,30,{|| SvuotaCampi() })
  FV3_Button('Test'        ,100,30,{|| MyTest() })
  *
  FV3_Show(1)
  *
  If FV3_Result()
     *
  Endif
  *
Return
*
Procedure Modifica()
  Local c1,c2,nRec
  *
  nRec := FV3_GetProperty('BROW4','Value')
  (cAlias)->(Dbgoto(nRec))
  *
  c1 := Left((cAlias)->Nome,15)
  c2 := MyInputBox('Nome '+(cAlias)->Codice,'Modifica',c1)
  *
  If !Empty(c2)
     (cAlias)->(dbgoto(nRec))
     Replace (cAlias)->Nome with Left(c2,15)
     FV3_SetProperty('BROW4','Value',(cAlias)->(Recno()))
     FV3_Refresh('BROW4')
  Endif
  *
Return
*
Procedure MyInputBox(cDesc,cCaption,cText,cPict)
  Local cRet := ''
  *
  hb_default(@cPict,'')
  *
  FV3_OpenModal(cCaption)
  FV3_SetValue('STRING',cText)
  *
  FV3_Label(cDesc,250)
  FV3_SkipRow(25)
  FV3_TextBox('STRING' ,250,cPict)
  *
  FV3_Show(2)
  *
  If FV3_Result()
     cRet := Trim(FV3_GetValue('STRING'))
  endif
  *
Return cRet
*
Procedure Statistiche()
  Local cText
  *
  cText := [Bingo ]+ntrim(nTestBingo)+;
  CRLF+;
  [Ordine Sequenza:]+;
  CRLF+;
  cSequ+;
  CRLF+CRLF+;
  [Ordine Ascendente:]+;
  CRLF+;
  cAsce+CRLF
  *
  FV3_OpenModal('Statistiche')
  FV3_SetValue('STAT',cText)
  *
  FV3_EditBox('STAT',900,300,nil)
  FV3_Show(1)
  *
  If FV3_Result()
  Endif
  *
Return
*
Procedure G2_OnChange(cWin,cName)
  Local nPos
  *
  If GetProperty(cWin,cName,'Value')
     aadd(aGames,{2,{|| (alias())->N1 == 2 .or. (alias())->N2 == 2 .or. (alias())->N3 == 2 },'Ambo'})
     *
     asort(aGames,,,{|x,y| x[1] < y[1] })
     *
  else
     nPos := ascan(aGames,{|x| x[1] == 2 })
     If nPos > 0
        aKill(aGames,nPos)
     Endif
  endif
  *
Return
*
Procedure G3_OnChange(cWin,cName)
  Local nPos
  *
  If GetProperty(cWin,cName,'Value')
     aadd(aGames,{3,{|| (alias())->N1 == 3 .or. (alias())->N2 == 3 .or. (alias())->N3 == 3 },'Terno'})
     *
     asort(aGames,,,{|x,y| x[1] < y[1] })
     *
  else
     nPos := ascan(aGames,{|x| x[1] == 3 })
     If nPos > 0
        aKill(aGames,nPos)
     Endif
  endif
  *
Return
*
Procedure G4_OnChange(cWin,cName)
  Local nPos := 0
  *
  If GetProperty(cWin,cName,'Value')
     aadd(aGames,{4,{|| (alias())->N1 == 4 .or. (alias())->N2 == 4 .or. (alias())->N3 == 4 },'Quaterna'})
     *
     asort(aGames,,,{|x,y| x[1] < y[1] })
     *
  else
     nPos := ascan(aGames,{|x| x[1] == 4 })
     If nPos > 0
        aKill(aGames,nPos)
     Endif
  endif
  *
Return
*
Procedure G5_OnChange(cWin,cName)
  Local nPos := 0,n
  *
  If GetProperty(cWin,cName,'Value')
     aadd(aGames,{5,{|| (alias())->N1 == 5 .or. (alias())->N2 == 5 .or. (alias())->N3 == 5 },'Cinquina'})
     *
     asort(aGames,,,{|x,y| x[1] < y[1] })
     *
  else
     nPos := ascan(aGames,{|x| x[1] == 5 })
     If nPos > 0
        aKill(aGames,nPos)
     Endif
  endif
  *
Return
*
Procedure SvuotaCampi()
  *
  (alias())->(dbgotop())
  Do while (alias())->(!Eof())
     *
     Replace (cAlias)->Nome with space(15)
     Replace (cAlias)->N1   with 0
     Replace (cAlias)->N2   with 0
     Replace (cAlias)->N3   with 0
     *
     (cAlias)->(dbskip())
     *
  Enddo
  (cAlias)->(dbgotop())
  FV3_SetProperty('BROW4','Value',(cAlias)->(Recno()))
  FV3_Refresh('BROW4')
  *
Return
*
Procedure MyTest()
  Local aRow1 := {}
  Local i,j
  *
  aadd(aRow1,'Fox'     )
  aadd(aRow1,'Max'     )
  aadd(aRow1,'Pepe'    )
  aadd(aRow1,'James'   )
  aadd(aRow1,'Carlos'  )
  aadd(aRow1,'Ned'     )
  aadd(aRow1,'John'    )
  aadd(aRow1,'Flavio'  )
  aadd(aRow1,'Juan'    )
  aadd(aRow1,'Raul'    )
  *
  (cAlias)->(dbgotop())
  Locate For empty((cAlias)->Nome)
  For j := 1 To Len(aRow1)
     Replace (cAlias)->Nome With aRow1[j]
     (cAlias)->(dbskip())
  Next
  (cAlias)->(dbgotop())
  FV3_SetProperty('BROW4','Value',(cAlias)->(Recno()))
  FV3_Refresh('BROW4')
  *
Return
*
Procedure MultiSelect2(cAlias)
  Local aRows  := {}
  Local a1     := {}
  Local a2     := {}
  Local Scelta
  Local c1
  *
  dbselectarea(cAlias)
  (cAlias)->(dbgotop())
  Do while (cAlias)->(!Eof())
     If !Empty(Trim((cAlias)->Nome))
        If ascan(a1,Upper(Trim((cAlias)->Nome))) == 0
           aadd(a1,Upper(Trim((cAlias)->Nome)))
        Endif
        aadd(a2,{Trim(Upper((cAlias)->Nome)),val((cAlias)->Codice)})
     Endif
     (cAlias)->(dbskip())
  Enddo
  aRows := {}
  If !Empty(a1)
     Scelta := MyChoice(400,300,a1,'Selezione',1)
     If Scelta > 0
        c1 := a1[Scelta]
        for i := 1 To Len(a2)
           If a2[i,1] == c1
              aadd(aRows,a2[i,2])
           Endif
        Next
     endif
  Endif
  (cAlias)->(dbgotop())
  *
Return aRows
*
PROCEDURE OrdinaColonne_90_9(c1)
  Local a1,a2
  Local x1,x2,x3,x4,x5,x6,x7,x8,x9
  *
  a2      :=   {'','','','','','','','',''}
  *
  a1      :=   array(5)
  a1[1]   :=   Trim(Substr(c1,1,3))
  a1[2]   :=   Trim(Substr(c1,4,3))
  a1[3]   :=   Trim(Substr(c1,7,3))
  a1[4]   :=   Trim(Substr(c1,10,3))
  a1[5]   :=   Trim(Substr(c1,13,3))
  *
  x1 := [01 02 03 04 05 06 07 08 09]
  x2 := [10 11 12 13 14 15 16 17 18 19]
  x3 := [20 21 22 23 24 25 26 27 28 29]
  x4 := [30 31 32 33 34 35 36 37 38 39]
  x5 := [40 41 42 43 44 45 46 47 48 49]
  x6 := [50 51 52 53 54 55 56 57 58 59]
  x7 := [60 61 62 63 64 65 66 67 68 69]
  x8 := [70 71 72 73 74 75 76 77 78 79]
  x9 := [80 81 82 83 84 85 86 87 88 89 90]
  For i   :=   1 To Len(a1)
     If a1[i] $     x1
        a2[1] := a1[1]
     elseIf a1[i] $ x2
        a2[2] := a1[i]
     elseIf a1[i] $ x3
        a2[3] := a1[i]
     elseIf a1[i] $ x4
        a2[4] := a1[i]
     elseIf a1[i] $ x5
        a2[5] := a1[i]
     elseIf a1[i] $ x6
        a2[6] := a1[i]
     elseIf a1[i] $ x7
        a2[7] := a1[i]
     elseIf a1[i] $ x8
        a2[8] := a1[i]
     elseIf a1[i] $ x9
        a2[9] := a1[i]
     Endif
  Next
  *
Return a2
*
PROCEDURE OrdinaColonne_75_9(c1)
  Local a1,a2,i
  Local x1,x2,x3,x4,x5,x6,x7,x8,x9
  *
  a2 := {'','','','','','','','',''}
  *
  a1      :=   array(5)
  a1[1]   :=   Trim(Substr(c1,1,3))
  a1[2]   :=   Trim(Substr(c1,4,3))
  a1[3]   :=   Trim(Substr(c1,7,3))
  a1[4]   :=   Trim(Substr(c1,10,3))
  a1[5]   :=   Trim(Substr(c1,13,3))
  *
  *
  x1 := [01 02 03 04 05 06 07]
  x2 := [08 09 10 11 12 13 14 15]
  x3 := [16 17 18 19 20 21 22 23 24 25]
  x4 := [26 27 28 29 30 31 32 33 34 35]
  x5 := [36 37 38 39 40 41 42 43]
  x6 := [44 45 46 47 48 49 50]
  x7 := [51 52 53 54 55 56 57 58 59 60]
  x8 := [61 62 63 64 65 66 67 68 69 70]
  x9 := [71 72 73 74 75]
  *
  For i   :=   1 To Len(a1)
     *
     If a1[i] $     x1
        a2[1] := a1[1]
     elseIf a1[i] $ x2
        a2[2] := a1[i]
     elseIf a1[i] $ x3
        a2[3] := a1[i]
     elseIf a1[i] $ x4
        a2[4] := a1[i]
     elseIf a1[i] $ x5
        a2[5] := a1[i]
     elseIf a1[i] $ x6
        a2[6] := a1[i]
     elseIf a1[i] $ x7
        a2[7] := a1[i]
     elseIf a1[i] $ x8
        a2[8] := a1[i]
     elseIf a1[i] $ x9
        a2[9] := a1[i]
     Endif
     *
  Next
  *
Return a2
*
PROCEDURE XYZ(n1,n2,aLista,aEstratti,aCol)
  Local nReturn
  Local Num
  *
  Do while .T.
     Num := hb_RandomInt(n1,n2)
     if ascan(aLista,Num) == 0
        aadd(aLista,Num)
        nReturn := Num
        exit
     endif
  Enddo
  aadd(aCol,Num)
  *
Return
*
